Index: globals_defs_0x72.html
===================================================================
--- globals_defs_0x72.html	(revision 1144)
+++ globals_defs_0x72.html	(revision 1145)
@@ -4,66 +4,75 @@
 <link href="doxygen.css" rel="stylesheet" type="text/css">
 <link href="tabs.css" rel="stylesheet" type="text/css">
 </head><body>
-<!-- Generated by Doxygen 1.5.3 -->
-<div class="tabs">
-  <ul>
-    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
-    <li><a href="modules.html"><span>Modules</span></a></li>
-    <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
-    <li class="current"><a href="files.html"><span>Files</span></a></li>
-    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
-  </ul>
-</div>
-<div class="tabs">
-  <ul>
-    <li><a href="files.html"><span>File&nbsp;List</span></a></li>
-    <li class="current"><a href="globals.html"><span>Globals</span></a></li>
-  </ul>
-</div>
-<div class="tabs">
-  <ul>
-    <li><a href="globals.html"><span>All</span></a></li>
-    <li><a href="globals_func.html"><span>Functions</span></a></li>
-    <li><a href="globals_type.html"><span>Typedefs</span></a></li>
-    <li class="current"><a href="globals_defs.html"><span>Defines</span></a></li>
-  </ul>
-</div>
-<div class="tabs">
-  <ul>
-    <li><a href="globals_defs.html#index__"><span>_</span></a></li>
-    <li><a href="globals_defs_0x61.html#index_a"><span>a</span></a></li>
-    <li><a href="globals_defs_0x62.html#index_b"><span>b</span></a></li>
-    <li><a href="globals_defs_0x63.html#index_c"><span>c</span></a></li>
-    <li><a href="globals_defs_0x64.html#index_d"><span>d</span></a></li>
-    <li><a href="globals_defs_0x65.html#index_e"><span>e</span></a></li>
-    <li><a href="globals_defs_0x66.html#index_f"><span>f</span></a></li>
-    <li><a href="globals_defs_0x67.html#index_g"><span>g</span></a></li>
-    <li><a href="globals_defs_0x68.html#index_h"><span>h</span></a></li>
-    <li><a href="globals_defs_0x69.html#index_i"><span>i</span></a></li>
-    <li><a href="globals_defs_0x6c.html#index_l"><span>l</span></a></li>
-    <li><a href="globals_defs_0x6d.html#index_m"><span>m</span></a></li>
-    <li><a href="globals_defs_0x6e.html#index_n"><span>n</span></a></li>
-    <li><a href="globals_defs_0x6f.html#index_o"><span>o</span></a></li>
-    <li><a href="globals_defs_0x70.html#index_p"><span>p</span></a></li>
-    <li><a href="globals_defs_0x71.html#index_q"><span>q</span></a></li>
-    <li class="current"><a href="globals_defs_0x72.html#index_r"><span>r</span></a></li>
-    <li><a href="globals_defs_0x73.html#index_s"><span>s</span></a></li>
-    <li><a href="globals_defs_0x74.html#index_t"><span>t</span></a></li>
-    <li><a href="globals_defs_0x75.html#index_u"><span>u</span></a></li>
-    <li><a href="globals_defs_0x77.html#index_w"><span>w</span></a></li>
-    <li><a href="globals_defs_0x78.html#index_x"><span>x</span></a></li>
-    <li><a href="globals_defs_0x79.html#index_y"><span>y</span></a></li>
-  </ul>
-</div>
+<!-- Generated by Doxygen 1.5.5 -->
+<div class="navigation" id="top">
+  <div class="tabs">
+    <ul>
+      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
+      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
+      <li><a href="modules.html"><span>Modules</span></a></li>
+      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
+      <li class="current"><a href="files.html"><span>Files</span></a></li>
+    </ul>
+  </div>
+  <div class="tabs">
+    <ul>
+      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
+      <li class="current"><a href="globals.html"><span>Globals</span></a></li>
+    </ul>
+  </div>
+  <div class="tabs">
+    <ul>
+      <li><a href="globals.html"><span>All</span></a></li>
+      <li><a href="globals_func.html"><span>Functions</span></a></li>
+      <li><a href="globals_type.html"><span>Typedefs</span></a></li>
+      <li class="current"><a href="globals_defs.html"><span>Defines</span></a></li>
+    </ul>
+  </div>
+  <div class="tabs">
+    <ul>
+      <li><a href="globals_defs.html#index__"><span>_</span></a></li>
+      <li><a href="globals_defs_0x61.html#index_a"><span>a</span></a></li>
+      <li><a href="globals_defs_0x62.html#index_b"><span>b</span></a></li>
+      <li><a href="globals_defs_0x63.html#index_c"><span>c</span></a></li>
+      <li><a href="globals_defs_0x64.html#index_d"><span>d</span></a></li>
+      <li><a href="globals_defs_0x65.html#index_e"><span>e</span></a></li>
+      <li><a href="globals_defs_0x66.html#index_f"><span>f</span></a></li>
+      <li><a href="globals_defs_0x67.html#index_g"><span>g</span></a></li>
+      <li><a href="globals_defs_0x68.html#index_h"><span>h</span></a></li>
+      <li><a href="globals_defs_0x69.html#index_i"><span>i</span></a></li>
+      <li><a href="globals_defs_0x6c.html#index_l"><span>l</span></a></li>
+      <li><a href="globals_defs_0x6d.html#index_m"><span>m</span></a></li>
+      <li><a href="globals_defs_0x6e.html#index_n"><span>n</span></a></li>
+      <li><a href="globals_defs_0x6f.html#index_o"><span>o</span></a></li>
+      <li><a href="globals_defs_0x70.html#index_p"><span>p</span></a></li>
+      <li><a href="globals_defs_0x71.html#index_q"><span>q</span></a></li>
+      <li class="current"><a href="globals_defs_0x72.html#index_r"><span>r</span></a></li>
+      <li><a href="globals_defs_0x73.html#index_s"><span>s</span></a></li>
+      <li><a href="globals_defs_0x74.html#index_t"><span>t</span></a></li>
+      <li><a href="globals_defs_0x75.html#index_u"><span>u</span></a></li>
+      <li><a href="globals_defs_0x77.html#index_w"><span>w</span></a></li>
+      <li><a href="globals_defs_0x78.html#index_x"><span>x</span></a></li>
+      <li><a href="globals_defs_0x79.html#index_y"><span>y</span></a></li>
+    </ul>
+  </div>
 
 <p>
+</div>
+<div class="contents">
 &nbsp;
 <p>
 <h3><a class="anchor" name="index_r">- r -</a></h3><ul>
+<li>RANGE
+: <a class="el" href="group__dragonfly.html#gc04dd0afaf7ea3eb2ade2544d2d5f907">dragonfly_lib.h</a>
 <li>RBOM
 : <a class="el" href="group__bom.html#g1ff400a0e77d2266138b080061f49d01">bom.h</a>
 <li>RED
 : <a class="el" href="group__orbs.html#g8d23feea868a983c8c2b661e1e16972f">lights.h</a>
+<li>RELEASE_LOCK
+: <a class="el" href="dragonfly__lib_8h.html#c25d1a234d2aa700c3d5cce7ecff803a">dragonfly_lib.h</a>
+<li>REQUIRE_LOCK_OR_RETURN
+: <a class="el" href="dragonfly__lib_8h.html#63040a270fd14fe3286e2b67e5927eb9">dragonfly_lib.h</a>
 <li>RING_BUFFER_ADD
 : <a class="el" href="ring__buffer_8h.html#7708daab49219e2fd35534bc9cd15245">ring_buffer.h</a>
 <li>RING_BUFFER_CLEAR
@@ -81,8 +90,9 @@
 <li>RING_BUFFER_REMOVE
 : <a class="el" href="ring__buffer_8h.html#4a0f9de5ac14f60d678cda392921a629">ring_buffer.h</a>
 </ul>
-<hr size="1"><address style="text-align: right;"><small>Generated on Wed Nov 5 19:59:43 2008 for libdragonfly by&nbsp;
+</div>
+<hr size="1"><address style="text-align: right;"><small>Generated on Thu Apr 16 18:33:23 2009 for libdragonfly by&nbsp;
 <a href="http://www.doxygen.org/index.html">
-<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.3 </small></address>
+<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.5 </small></address>
 </body>
 </html>