Index: group__buzzer.html
===================================================================
--- group__buzzer.html	(revision 1144)
+++ group__buzzer.html	(revision 1145)
@@ -4,16 +4,19 @@
 <link href="doxygen.css" rel="stylesheet" type="text/css">
 <link href="tabs.css" rel="stylesheet" type="text/css">
 </head><body>
-<!-- Generated by Doxygen 1.5.3 -->
-<div class="tabs">
-  <ul>
-    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
-    <li><a href="modules.html"><span>Modules</span></a></li>
-    <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
-    <li><a href="files.html"><span>Files</span></a></li>
-    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
-  </ul>
+<!-- Generated by Doxygen 1.5.5 -->
+<div class="navigation" id="top">
+  <div class="tabs">
+    <ul>
+      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
+      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
+      <li><a href="modules.html"><span>Modules</span></a></li>
+      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
+      <li><a href="files.html"><span>Files</span></a></li>
+    </ul>
+  </div>
 </div>
+<div class="contents">
 <h1>Buzzer</h1>Functions for controlling the buzzer. Functions for controlling the buzzer. Include <a class="el" href="buzzer_8h.html" title="Contains definitions for using the buzzer.">buzzer.h</a> to access these functions.  
 <a href="#_details">More...</a><table border="0" cellpadding="0" cellspacing="0">
 <tr><td></td></tr>
@@ -128,6 +131,8 @@
 </dl>
 <dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__buzzer.html#g0cead532fdd0c0de5fa1c1de0f6556bd" title="Initialize the buzzer.">buzzer_init</a>, <a class="el" href="group__buzzer.html#ga0aba85b0044cb1a44bb28c675d7c193" title="Set the frequency the buzzer plays.">buzzer_set_freq</a> </dd></dl>
 
+<p>References <a class="el" href="buzzer_8c-source.html#l00127">buzzer_off()</a>, <a class="el" href="buzzer_8c-source.html#l00089">buzzer_set_freq()</a>, and <a class="el" href="time_8c-source.html#l00104">delay_ms()</a>.</p>
+
 </div>
 </div><p>
 <a class="anchor" name="g0cead532fdd0c0de5fa1c1de0f6556bd"></a><!-- doxytag: member="buzzer.c::buzzer_init" ref="g0cead532fdd0c0de5fa1c1de0f6556bd" args="(void)" -->
@@ -150,6 +155,8 @@
 Initialize the buzzer. 
 <p>
 Initializes the buzzer. Must be called before any other buzzer function may be used. 
+<p>Referenced by <a class="el" href="dragonfly__lib_8c-source.html#l00068">dragonfly_init()</a>.</p>
+
 </div>
 </div><p>
 <a class="anchor" name="g93d07c81691fec7a85ea85117d6eca4f"></a><!-- doxytag: member="buzzer.c::buzzer_off" ref="g93d07c81691fec7a85ea85117d6eca4f" args="(void)" -->
@@ -173,6 +180,8 @@
 Turns off the buzzer by disabling the timer0 clock.<p>
 <dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__buzzer.html#g0cead532fdd0c0de5fa1c1de0f6556bd" title="Initialize the buzzer.">buzzer_init</a> </dd></dl>
 
+<p>Referenced by <a class="el" href="buzzer_8c-source.html#l00115">buzzer_chirp()</a>.</p>
+
 </div>
 </div><p>
 <a class="anchor" name="ga0aba85b0044cb1a44bb28c675d7c193"></a><!-- doxytag: member="buzzer.c::buzzer_set_freq" ref="ga0aba85b0044cb1a44bb28c675d7c193" args="(unsigned int buzz_freq)" -->
@@ -202,6 +211,10 @@
 </dl>
 <dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__buzzer.html#g0cead532fdd0c0de5fa1c1de0f6556bd" title="Initialize the buzzer.">buzzer_init</a>, <a class="el" href="group__buzzer.html#g9872f05325dd86a89728d47c8e9158ab" title="Set the value the buzzer plays.">buzzer_set_val</a>, <a class="el" href="group__buzzer.html#g93d07c81691fec7a85ea85117d6eca4f" title="Turn the buzzer off.">buzzer_off</a> </dd></dl>
 
+<p>References <a class="el" href="buzzer_8c-source.html#l00072">buzzer_set_val()</a>.</p>
+
+<p>Referenced by <a class="el" href="buzzer_8c-source.html#l00115">buzzer_chirp()</a>.</p>
+
 </div>
 </div><p>
 <a class="anchor" name="g9872f05325dd86a89728d47c8e9158ab"></a><!-- doxytag: member="buzzer.c::buzzer_set_val" ref="g9872f05325dd86a89728d47c8e9158ab" args="(unsigned int buzz_value)" -->
@@ -231,10 +244,13 @@
 </dl>
 <dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__buzzer.html#g0cead532fdd0c0de5fa1c1de0f6556bd" title="Initialize the buzzer.">buzzer_init</a>, <a class="el" href="group__buzzer.html#ga0aba85b0044cb1a44bb28c675d7c193" title="Set the frequency the buzzer plays.">buzzer_set_freq</a>, <a class="el" href="group__buzzer.html#g93d07c81691fec7a85ea85117d6eca4f" title="Turn the buzzer off.">buzzer_off</a> </dd></dl>
 
+<p>Referenced by <a class="el" href="buzzer_8c-source.html#l00089">buzzer_set_freq()</a>.</p>
+
 </div>
 </div><p>
-<hr size="1"><address style="text-align: right;"><small>Generated on Wed Nov 5 19:59:43 2008 for libdragonfly by&nbsp;
+</div>
+<hr size="1"><address style="text-align: right;"><small>Generated on Thu Apr 16 18:33:23 2009 for libdragonfly by&nbsp;
 <a href="http://www.doxygen.org/index.html">
-<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.3 </small></address>
+<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.5 </small></address>
 </body>
 </html>