Index: group__dragonfly.html
===================================================================
--- group__dragonfly.html	(revision 1144)
+++ group__dragonfly.html	(revision 1145)
@@ -4,16 +4,19 @@
 <link href="doxygen.css" rel="stylesheet" type="text/css">
 <link href="tabs.css" rel="stylesheet" type="text/css">
 </head><body>
-<!-- Generated by Doxygen 1.5.3 -->
-<div class="tabs">
-  <ul>
-    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
-    <li><a href="modules.html"><span>Modules</span></a></li>
-    <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
-    <li><a href="files.html"><span>Files</span></a></li>
-    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
-  </ul>
+<!-- Generated by Doxygen 1.5.5 -->
+<div class="navigation" id="top">
+  <div class="tabs">
+    <ul>
+      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
+      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
+      <li><a href="modules.html"><span>Modules</span></a></li>
+      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
+      <li><a href="files.html"><span>Files</span></a></li>
+    </ul>
+  </div>
 </div>
+<div class="contents">
 <h1>Dragonfly</h1>General Dragonfly Functions General functions for the dragonfly. Include <a class="el" href="dragonfly__lib_8h.html" title="Contains other include files.">dragonfly_lib.h</a> to access these functions.  
 <a href="#_details">More...</a><table border="0" cellpadding="0" cellspacing="0">
 <tr><td></td></tr>
@@ -42,39 +45,51 @@
 #define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#g9bb31bba359fbb679910df0a6efde5a3">MOTORS</a>&nbsp;&nbsp;&nbsp;0x08</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the motors. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="g457a9aa93dbb216459873a30bdb4d84a"></a><!-- doxytag: member="dragonfly::I2C" ref="g457a9aa93dbb216459873a30bdb4d84a" args="" -->
+#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#g457a9aa93dbb216459873a30bdb4d84a">I2C</a>&nbsp;&nbsp;&nbsp;0x20</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize I2C. <br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="g145103118f6d9d1129aa4509cf214a13"></a><!-- doxytag: member="dragonfly::BUZZER" ref="g145103118f6d9d1129aa4509cf214a13" args="" -->
-#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#g145103118f6d9d1129aa4509cf214a13">BUZZER</a>&nbsp;&nbsp;&nbsp;0x10</td></tr>
+#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#g145103118f6d9d1129aa4509cf214a13">BUZZER</a>&nbsp;&nbsp;&nbsp;0x40</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the buzzer. <br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="gbf2d80992dcfabfd1668184c3dff2733"></a><!-- doxytag: member="dragonfly::LCD" ref="gbf2d80992dcfabfd1668184c3dff2733" args="" -->
-#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#gbf2d80992dcfabfd1668184c3dff2733">LCD</a>&nbsp;&nbsp;&nbsp;0x20</td></tr>
+#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#gbf2d80992dcfabfd1668184c3dff2733">LCD</a>&nbsp;&nbsp;&nbsp;0x80</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the LCD screen. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="gc04dd0afaf7ea3eb2ade2544d2d5f907"></a><!-- doxytag: member="dragonfly::RANGE" ref="gc04dd0afaf7ea3eb2ade2544d2d5f907" args="" -->
+#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#gc04dd0afaf7ea3eb2ade2544d2d5f907">RANGE</a>&nbsp;&nbsp;&nbsp;0x0100</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the rangefinders. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="gd555cfe7a1fcf16c3639f797120478eb"></a><!-- doxytag: member="dragonfly::BOM" ref="gd555cfe7a1fcf16c3639f797120478eb" args="" -->
+#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#gd555cfe7a1fcf16c3639f797120478eb">BOM</a>&nbsp;&nbsp;&nbsp;0x0200</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the BOM. <br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="g1252cf7a07df96ed2561ae605eaca197"></a><!-- doxytag: member="dragonfly::ALL_ON" ref="g1252cf7a07df96ed2561ae605eaca197" args="" -->
-#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#g1252cf7a07df96ed2561ae605eaca197">ALL_ON</a>&nbsp;&nbsp;&nbsp;0xFF</td></tr>
+#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#g1252cf7a07df96ed2561ae605eaca197">ALL_ON</a>&nbsp;&nbsp;&nbsp;0x03FF</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize everything. <br></td></tr>
 <tr><td colspan="2"><br><h2>Functions</h2></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#g8124e2c32bf25208586d500e45ba5fe3">dragonfly_init</a> (int config)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#g11289903a89d284a2d7acbe5fbf8d9f9">flash_red</a> (void)</td></tr>
 
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the board.  <a href="#g8124e2c32bf25208586d500e45ba5fe3"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="g8124e2c32bf25208586d500e45ba5fe3"></a><!-- doxytag: member="dragonfly::dragonfly_init" ref="g8124e2c32bf25208586d500e45ba5fe3" args="(int config)" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__dragonfly.html#g8124e2c32bf25208586d500e45ba5fe3">dragonfly_init</a> (int config)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the board. <br></td></tr>
 </table>
 <hr><a name="_details"></a><h2>Detailed Description</h2>
 General Dragonfly Functions General functions for the dragonfly. Include <a class="el" href="dragonfly__lib_8h.html" title="Contains other include files.">dragonfly_lib.h</a> to access these functions. 
 <p>
-init_dragonfly - Initializes functions based on configuration parameters examples:<p>
-init_dragonfly (ALL_ON); - Turns on all basic subsystems. More complex ones that require their own configuration parameters must still be called on their own.<p>
-init_dragonfly (ANALOG | SERIAL | BUZZER); Initialize ADC, USB, XBee, and Buzzer<p>
-init_dragonfly (MOTORS | ORB); Initialize the motors and ORB. <hr><h2>Function Documentation</h2>
-<a class="anchor" name="g8124e2c32bf25208586d500e45ba5fe3"></a><!-- doxytag: member="dragonfly_lib.c::dragonfly_init" ref="g8124e2c32bf25208586d500e45ba5fe3" args="(int config)" -->
+<hr><h2>Function Documentation</h2>
+<a class="anchor" name="g11289903a89d284a2d7acbe5fbf8d9f9"></a><!-- doxytag: member="dragonfly_lib.c::flash_red" ref="g11289903a89d284a2d7acbe5fbf8d9f9" args="(void)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void dragonfly_init           </td>
+          <td class="memname">void flash_red           </td>
           <td>(</td>
-          <td class="paramtype">int&nbsp;</td>
-          <td class="paramname"> <em>config</em>          </td>
+          <td class="paramtype">void&nbsp;</td>
+          <td class="paramname">          </td>
           <td>&nbsp;)&nbsp;</td>
           <td width="100%"></td>
         </tr>
@@ -83,20 +98,18 @@
 <div class="memdoc">
 
 <p>
-Initialize the board. 
-<p>
-Initializes the components specified by config. Will turn on interrupts automatically.<p>
-<dl compact><dt><b>Parameters:</b></dt><dd>
-  <table border="0" cellspacing="2" cellpadding="0">
-    <tr><td valign="top"></td><td valign="top"><em>config</em>&nbsp;</td><td>The subsystems that you wish to turn on. Check <a class="el" href="dragonfly__lib_8h.html" title="Contains other include files.">dragonfly_lib.h</a> for valid values.</td></tr>
-  </table>
-</dl>
-<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__analog.html#g4be2ba5e4db17e5be950af682f9ad522" title="Initialize analog ports. Will start running a loop if start_conversion is ADC_START...">analog_init</a>, <a class="el" href="group__usb.html#gddfbdb66f507ffcd08b4496531ed0a3d" title="Initialize the USB.">usb_init</a>, <a class="el" href="group__xbee.html#g964a1e8461e9c1187e5d69f521e5e107" title="Initialize the XBee.">xbee_init</a>, <a class="el" href="group__buzzer.html#g0cead532fdd0c0de5fa1c1de0f6556bd" title="Initialize the buzzer.">buzzer_init</a>, <a class="el" href="group__bom.html#g101f932380b02b48a0ca3d20ffc8c08f" title="Initialize the bom according to bom type.">bom_init</a>, <a class="el" href="group__orbs.html#g13069271f9d636674e9b4a8a355099b9" title="Enables the orbs.">orb_init</a>, <a class="el" href="group__motors.html#gbad32bfc46c9f31ba81955775611bd21" title="Initialize the motors.">motors_init</a>, <a class="el" href="group__lcd.html#g6842775ba83d166f02b8fef8bb63b1e6" title="Initialize the LCD screen.">lcd_init</a> </dd></dl>
+Initializes the components specified by config.<p>
+<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__analog.html#g4be2ba5e4db17e5be950af682f9ad522" title="Initialize analog ports. Will start running a loop if start_conversion is ADC_START...">analog_init</a>, <a class="el" href="group__usb.html#gddfbdb66f507ffcd08b4496531ed0a3d" title="Initialize the USB.">usb_init</a>, <a class="el" href="group__xbee.html#g964a1e8461e9c1187e5d69f521e5e107" title="Initialize the XBee.">xbee_init</a>, <a class="el" href="group__buzzer.html#g0cead532fdd0c0de5fa1c1de0f6556bd" title="Initialize the buzzer.">buzzer_init</a>, <a class="el" href="group__bom.html#g101f932380b02b48a0ca3d20ffc8c08f" title="Initialize the bom according to bom type.">bom_init</a>, <a class="el" href="group__orbs.html#g13069271f9d636674e9b4a8a355099b9" title="Enables the orbs in default mode.">orb_init</a>, <a class="el" href="group__motors.html#gbad32bfc46c9f31ba81955775611bd21" title="Initialize the motors.">motors_init</a>, <a class="el" href="group__lcd.html#g6842775ba83d166f02b8fef8bb63b1e6" title="Initialize the LCD screen.">lcd_init</a> </dd></dl>
 
+<p>References <a class="el" href="time_8c-source.html#l00104">delay_ms()</a>.</p>
+
+<p>Referenced by <a class="el" href="dragonfly__lib_8c-source.html#l00068">dragonfly_init()</a>.</p>
+
 </div>
 </div><p>
-<hr size="1"><address style="text-align: right;"><small>Generated on Wed Nov 5 19:59:43 2008 for libdragonfly by&nbsp;
+</div>
+<hr size="1"><address style="text-align: right;"><small>Generated on Thu Apr 16 18:33:23 2009 for libdragonfly by&nbsp;
 <a href="http://www.doxygen.org/index.html">
-<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.3 </small></address>
+<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.5 </small></address>
 </body>
 </html>