Index: trunk/code/projects/diagnostic_station/station/hardware_rbom.h
===================================================================
--- trunk/code/projects/diagnostic_station/station/hardware_rbom.h	(revision 1253)
+++ trunk/code/projects/diagnostic_station/station/hardware_rbom.h	(nonexistent)
@@ -1,24 +0,0 @@
-#ifndef _hardware_rbom_h
-#define _hardware_rbom_h
-
-#include <dragonfly_lib.h>
-#include "global.h"
-
-/* 
- * Inverse BOM sensor macros for (N)orth,
- * (S)outh, (E)ast, and (W)est positions.
- */
-// FIXME do it right
-#define RBOM_SENSOR_LEFT AN3
-#define RBOM_SENSOR_RIGHT AN4
-#define RBOM_SENSOR_TOP AN5
-//#define RBOM_SENSOR_ AN6
-
-void rbom_init (void);
-
-void rbom_set (bool on);
-void rbom_read (uint16_t *top, uint16_t *left, uint16_t *right);
-void rbom_update (void);
-void rbom_debug (void);
-
-#endif
Index: trunk/code/projects/diagnostic_station/station/hardware_rbom.c
===================================================================
--- trunk/code/projects/diagnostic_station/station/hardware_rbom.c	(revision 1253)
+++ trunk/code/projects/diagnostic_station/station/hardware_rbom.c	(nonexistent)
@@ -1,87 +0,0 @@
-#include "hardware_rbom.h"
-
-static void pDataDump(int startPort, int stopPort, unsigned int delay);
-static void pUsr(int startPort, int stopPort, unsigned int delay);
-
-void rbom_init (void)
-{
-	// FIXME implement
-}
-
-void rbom_set (bool on)
-{
-	if (on)
-	{
-		usb_puts ("# Turning RBOM light on" NL);
-		// FIXME implement
-	}
-	else
-	{
-		usb_puts ("# Turning RBOM light off" NL);
-		// FIXME implement
-	}
-}
-
-void rbom_read (uint16_t *top, uint16_t *left, uint16_t *right)
-{
-	usb_puts ("# Reading RBOM" NL);
-	// FIXME implement
-	
-	*top=0;
-	*left=0;
-	*right=0;
-}
-
-void rbom_update (void)
-{
-	// FIXME implement
-}
-
-void rbom_debug (void)
-{
-	usb_puts("# Debugging RBOM\n");
-
-	while(1) {
-		pUsr(0x0, 0x10, 500);
-	}
-
-	exit(1);	/* Control should never reach here */
-}
-
-static void pDataDump(int startPort, int stopPort, unsigned int delay) {
-
-	char buf[16];
-	int i;
-	
-	usb_puts("# port:\t\tval:\n\n");
-
-	for (i = startPort; i <= stopPort; i++) {
-
-		usb_puts(itoa(analog10(i), buf, 10));
-		usb_puts("\n");	
-	}
-
-	delay_ms(delay);
-
-}
-
-
-static void pUsr(int startPort, int stopPort, unsigned int delay) {
-
-	char buf[16];
-	int i;
-	
-	usb_puts("# port:\t\tval:\n\n");
-
-	for (i = startPort; i <= stopPort; i++) {
-
-		usb_puts(itoa(i, buf, 10));
-		usb_puts("\t\t");
-		usb_puts(itoa(analog10(i), buf, 10));
-		usb_puts("\n");
-	
-	}
-
-	delay_ms(delay);
-
-}
Index: trunk/code/projects/diagnostic_station/station/hardware.h
===================================================================
--- trunk/code/projects/diagnostic_station/station/hardware.h	(revision 1253)
+++ trunk/code/projects/diagnostic_station/station/hardware.h	(revision 1254)
@@ -6,7 +6,7 @@
 #include "global.h"
 
 #include "hardware_dynamos.h"
-#include "hardware_rbom.h"
+#include "hardware_ibom.h"
 #include "hardware_wall.h"
 #include "hardware_turntable.h"
 
Index: trunk/code/projects/diagnostic_station/station/hardware_ibom.c
===================================================================
--- trunk/code/projects/diagnostic_station/station/hardware_ibom.c	(nonexistent)
+++ trunk/code/projects/diagnostic_station/station/hardware_ibom.c	(revision 1254)
@@ -0,0 +1,87 @@
+#include "hardware_ibom.h"
+
+static void pDataDump(int startPort, int stopPort, unsigned int delay);
+static void pUsr(int startPort, int stopPort, unsigned int delay);
+
+void ibom_init (void)
+{
+	// FIXME implement
+}
+
+void ibom_set (bool on)
+{
+	if (on)
+	{
+		usb_puts ("# Turning RBOM light on" NL);
+		// FIXME implement
+	}
+	else
+	{
+		usb_puts ("# Turning RBOM light off" NL);
+		// FIXME implement
+	}
+}
+
+void ibom_read (uint16_t *top, uint16_t *left, uint16_t *right)
+{
+	usb_puts ("# Reading RBOM" NL);
+	// FIXME implement
+	
+	*top=0;
+	*left=0;
+	*right=0;
+}
+
+void ibom_update (void)
+{
+	// FIXME implement
+}
+
+void ibom_debug (void)
+{
+	usb_puts("# Debugging RBOM\n");
+
+	while(1) {
+		pUsr(0x0, 0x10, 500);
+	}
+
+	exit(1);	/* Control should never reach here */
+}
+
+static void pDataDump(int startPort, int stopPort, unsigned int delay) {
+
+	char buf[16];
+	int i;
+	
+	usb_puts("# port:\t\tval:\n\n");
+
+	for (i = startPort; i <= stopPort; i++) {
+
+		usb_puts(itoa(analog10(i), buf, 10));
+		usb_puts("\n");	
+	}
+
+	delay_ms(delay);
+
+}
+
+
+static void pUsr(int startPort, int stopPort, unsigned int delay) {
+
+	char buf[16];
+	int i;
+	
+	usb_puts("# port:\t\tval:\n\n");
+
+	for (i = startPort; i <= stopPort; i++) {
+
+		usb_puts(itoa(i, buf, 10));
+		usb_puts("\t\t");
+		usb_puts(itoa(analog10(i), buf, 10));
+		usb_puts("\n");
+	
+	}
+
+	delay_ms(delay);
+
+}
Index: trunk/code/projects/diagnostic_station/station/dump_station.c
===================================================================
--- trunk/code/projects/diagnostic_station/station/dump_station.c	(revision 1253)
+++ trunk/code/projects/diagnostic_station/station/dump_station.c	(revision 1254)
@@ -44,7 +44,7 @@
 	}
 }
 
-void dump_station_rbom (void)
+void dump_station_ibom (void)
 {
 	uint16_t top, left, right;
 	char c;
@@ -51,8 +51,8 @@
 
 	while (usb_getc_nb (&c)==-1)
 	{
-		rbom_update ();
-		rbom_read (&top, &left, &right);
+		ibom_update ();
+		ibom_read (&top, &left, &right);
 		usb_puti (top);
 		usb_puts (" ");
 		usb_puti (left);
Index: trunk/code/projects/diagnostic_station/station/hardware_ibom.h
===================================================================
--- trunk/code/projects/diagnostic_station/station/hardware_ibom.h	(nonexistent)
+++ trunk/code/projects/diagnostic_station/station/hardware_ibom.h	(revision 1254)
@@ -0,0 +1,24 @@
+#ifndef _hardware_ibom_h
+#define _hardware_ibom_h
+
+#include <dragonfly_lib.h>
+#include "global.h"
+
+/* 
+ * Inverse BOM sensor macros for (N)orth,
+ * (S)outh, (E)ast, and (W)est positions.
+ */
+// FIXME do it right
+#define RBOM_SENSOR_LEFT AN3
+#define RBOM_SENSOR_RIGHT AN4
+#define RBOM_SENSOR_TOP AN5
+//#define RBOM_SENSOR_ AN6
+
+void ibom_init (void);
+
+void ibom_set (bool on);
+void ibom_read (uint16_t *top, uint16_t *left, uint16_t *right);
+void ibom_update (void);
+void ibom_debug (void);
+
+#endif
Index: trunk/code/projects/diagnostic_station/station/dump_station.h
===================================================================
--- trunk/code/projects/diagnostic_station/station/dump_station.h	(revision 1253)
+++ trunk/code/projects/diagnostic_station/station/dump_station.h	(revision 1254)
@@ -5,7 +5,7 @@
 void dump_station_dynamos (void);
 void dump_station_turntable (void);
 void dump_station_wall (void);
-void dump_station_rbom (void);
+void dump_station_ibom (void);
 
 
 
Index: trunk/code/projects/diagnostic_station/station/test_bom.c
===================================================================
--- trunk/code/projects/diagnostic_station/station/test_bom.c	(revision 1253)
+++ trunk/code/projects/diagnostic_station/station/test_bom.c	(revision 1254)
@@ -2,7 +2,7 @@
 #include "global.h"
 
 #include "hardware_turntable.h"
-#include "hardware_rbom.h"
+#include "hardware_ibom.h"
 #include "comm_robot.h"
 
 static uint16_t bom_emitter_position (uint8_t num)
@@ -52,11 +52,11 @@
 			turntable_rotate_to_position (bom_emitter_position (n));
 			robot_set_bom (1<<n);
 		
-			rbom_update ();
+			ibom_update ();
 #define TOP 0
 #define LEFT 1
 #define RIGHT 2
-			rbom_read (&values[TOP], &values[LEFT], &values[RIGHT]);
+			ibom_read (&values[TOP], &values[LEFT], &values[RIGHT]);
 
 			robot_set_bom (0);
 
@@ -80,9 +80,9 @@
 
 			uint16_t on_value, off_value;
 
-			rbom_set (true);
+			ibom_set (true);
 			robot_read_bom (n, &on_value);
-			rbom_set (false);
+			ibom_set (false);
 			robot_read_bom (n, &off_value);
 
 			// Send data
Index: trunk/code/projects/diagnostic_station/station/comm_interactive.c
===================================================================
--- trunk/code/projects/diagnostic_station/station/comm_interactive.c	(revision 1253)
+++ trunk/code/projects/diagnostic_station/station/comm_interactive.c	(revision 1254)
@@ -22,7 +22,7 @@
 			case 'e': case 'E': dump_station_dynamos   (); break;
 			case 'w': case 'W': dump_station_wall      (); break;
 			case 't': case 'T': dump_station_turntable (); break;
-			case 'r': case 'R': dump_station_rbom      (); break;
+			case 'r': case 'R': dump_station_ibom      (); break;
 			case ESC: return;
 			default: break;
 		}
Index: trunk/code/projects/diagnostic_station/station/main.c
===================================================================
--- trunk/code/projects/diagnostic_station/station/main.c	(revision 1253)
+++ trunk/code/projects/diagnostic_station/station/main.c	(revision 1254)
@@ -104,7 +104,7 @@
 
 	orbs_set(255, 0,255,255,0,255);
 
-	rbom_debug();
+	ibom_debug();
 
 	return 0;
 }
Index: trunk/code/projects/diagnostic_station/station/hardware.c
===================================================================
--- trunk/code/projects/diagnostic_station/station/hardware.c	(revision 1253)
+++ trunk/code/projects/diagnostic_station/station/hardware.c	(revision 1254)
@@ -5,7 +5,7 @@
 	usb_puts ("# Initializing station hardware" NL);
 	
 	dynamos_init ();
-	rbom_init ();
+	ibom_init ();
 	wall_init ();
 	turntable_init ();
 }